build.sh 19 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715
  1. #!/usr/bin/env bash
  2. # Copyright 2018 Google
  3. #
  4. # Licensed under the Apache License, Version 2.0 (the "License");
  5. # you may not use this file except in compliance with the License.
  6. # You may obtain a copy of the License at
  7. #
  8. # http://www.apache.org/licenses/LICENSE-2.0
  9. #
  10. # Unless required by applicable law or agreed to in writing, software
  11. # distributed under the License is distributed on an "AS IS" BASIS,
  12. # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  13. # See the License for the specific language governing permissions and
  14. # limitations under the License.
  15. # USAGE: build.sh product [platform] [method]
  16. #
  17. # Builds the given product for the given platform using the given build method
  18. function pod_gen() {
  19. # Call pod gen with a podspec and additional optional arguments.
  20. bundle exec pod gen --local-sources=./ --sources=https://github.com/firebase/SpecsDev.git,https://github.com/firebase/SpecsStaging.git,https://cdn.cocoapods.org/ "$@"
  21. }
  22. set -euo pipefail
  23. if [[ $# -lt 1 ]]; then
  24. cat 1>&2 <<EOF
  25. USAGE: $0 product [platform] [method]
  26. product can be one of:
  27. Firebase
  28. Firestore
  29. CombineSwift
  30. InAppMessaging
  31. Messaging
  32. MessagingSample
  33. SwiftUISample
  34. MLModelDownloaderSample
  35. RemoteConfig
  36. RemoteConfigSample
  37. Sessions
  38. Storage
  39. SymbolCollision
  40. GoogleDataTransport
  41. Performance
  42. ClientApp
  43. platform can be one of:
  44. iOS (default)
  45. iOS-device
  46. macOS
  47. tvOS
  48. watchOS
  49. catalyst
  50. visionOS
  51. method can be one of:
  52. xcodebuild (default)
  53. cmake
  54. unit
  55. integration
  56. spm
  57. Optionally, reads the environment variable SANITIZERS. If set, it is expected to
  58. be a string containing a space-separated list with some of the following
  59. elements:
  60. asan
  61. tsan
  62. ubsan
  63. EOF
  64. exit 1
  65. fi
  66. product="$1"
  67. platform="iOS"
  68. if [[ $# -gt 1 ]]; then
  69. platform="$2"
  70. fi
  71. method="xcodebuild"
  72. if [[ $# -gt 2 ]]; then
  73. method="$3"
  74. fi
  75. echo "Building $product for $platform using $method"
  76. if [[ -n "${SANITIZERS:-}" ]]; then
  77. echo "Using sanitizers: $SANITIZERS"
  78. fi
  79. scripts_dir=$(dirname "${BASH_SOURCE[0]}")
  80. firestore_emulator="${scripts_dir}/run_firestore_emulator.sh"
  81. database_emulator="${scripts_dir}/run_database_emulator.sh"
  82. system=$(uname -s)
  83. case "$system" in
  84. Darwin)
  85. xcode_version=$(xcodebuild -version | grep Xcode)
  86. xcode_version="${xcode_version/Xcode /}"
  87. xcode_major="${xcode_version/.*/}"
  88. ;;
  89. *)
  90. xcode_major="0"
  91. ;;
  92. esac
  93. # Source function to check if CI secrets are available.
  94. source scripts/check_secrets.sh
  95. # Runs xcodebuild with the given flags, piping output to xcpretty
  96. # If xcodebuild fails with known error codes, retries once.
  97. function RunXcodebuild() {
  98. echo xcodebuild "$@"
  99. xcpretty_cmd=(xcpretty)
  100. result=0
  101. xcodebuild "$@" | tee xcodebuild.log | "${xcpretty_cmd[@]}" || result=$?
  102. if [[ $result == 65 ]]; then
  103. ExportLogs "$@"
  104. echo "xcodebuild exited with 65, retrying" 1>&2
  105. sleep 5
  106. result=0
  107. xcodebuild "$@" | tee xcodebuild.log | "${xcpretty_cmd[@]}" || result=$?
  108. fi
  109. if [[ $result != 0 ]]; then
  110. echo "xcodebuild exited with $result" 1>&2
  111. ExportLogs "$@"
  112. return $result
  113. fi
  114. }
  115. # Exports any logs output captured in the xcresult
  116. function ExportLogs() {
  117. python "${scripts_dir}/xcresult_logs.py" "$@"
  118. }
  119. if [[ "$xcode_major" -lt 15 ]]; then
  120. ios_flags=(
  121. -sdk 'iphonesimulator'
  122. -destination 'platform=iOS Simulator,name=iPhone 14'
  123. )
  124. else
  125. ios_flags=(
  126. -sdk 'iphonesimulator'
  127. -destination 'platform=iOS Simulator,name=iPhone 15'
  128. )
  129. fi
  130. ios_device_flags=(
  131. -sdk 'iphoneos'
  132. -destination 'generic/platform=iOS'
  133. )
  134. ipad_flags=(
  135. -sdk 'iphonesimulator'
  136. -destination 'platform=iOS Simulator,name=iPad Pro (9.7-inch)'
  137. )
  138. macos_flags=(
  139. -sdk 'macosx'
  140. -destination 'platform=OS X,arch=x86_64'
  141. )
  142. tvos_flags=(
  143. -sdk "appletvsimulator"
  144. -destination 'platform=tvOS Simulator,name=Apple TV'
  145. )
  146. watchos_flags=(
  147. -sdk 'watchsimulator'
  148. -destination 'platform=watchOS Simulator,name=Apple Watch Series 7 (45mm)'
  149. )
  150. visionos_flags=(
  151. -sdk 'xrsimulator'
  152. -destination 'platform=visionOS Simulator,name=Apple Vision Pro'
  153. )
  154. catalyst_flags=(
  155. ARCHS=x86_64 VALID_ARCHS=x86_64 SUPPORTS_MACCATALYST=YES -sdk macosx
  156. -destination platform="macOS,variant=Mac Catalyst,arch=x86_64" TARGETED_DEVICE_FAMILY=2
  157. CODE_SIGN_IDENTITY=- CODE_SIGNING_REQUIRED=NO CODE_SIGNING_ALLOWED=NO
  158. )
  159. # Compute standard flags for all platforms
  160. case "$platform" in
  161. iOS)
  162. xcb_flags=("${ios_flags[@]}")
  163. gen_platform=ios
  164. ;;
  165. iOS-device)
  166. xcb_flags=("${ios_device_flags[@]}")
  167. gen_platform=ios
  168. ;;
  169. iPad)
  170. xcb_flags=("${ipad_flags[@]}")
  171. ;;
  172. macOS)
  173. xcb_flags=("${macos_flags[@]}")
  174. gen_platform=macos
  175. ;;
  176. tvOS)
  177. xcb_flags=("${tvos_flags[@]}")
  178. gen_platform=tvos
  179. ;;
  180. watchOS)
  181. xcb_flags=("${watchos_flags[@]}")
  182. ;;
  183. visionOS)
  184. xcb_flags=("${visionos_flags[@]}")
  185. ;;
  186. catalyst)
  187. xcb_flags=("${catalyst_flags[@]}")
  188. ;;
  189. all)
  190. xcb_flags=()
  191. ;;
  192. Linux)
  193. xcb_flags=()
  194. ;;
  195. *)
  196. echo "Unknown platform '$platform'" 1>&2
  197. exit 1
  198. ;;
  199. esac
  200. xcb_flags+=(
  201. ONLY_ACTIVE_ARCH=YES
  202. CODE_SIGNING_REQUIRED=NO
  203. CODE_SIGNING_ALLOWED=YES
  204. COMPILER_INDEX_STORE_ENABLE=NO
  205. )
  206. source scripts/buildcache.sh
  207. xcb_flags=("${xcb_flags[@]}" "${buildcache_xcb_flags[@]}")
  208. # TODO(varconst): Add --warn-unused-vars and --warn-uninitialized.
  209. # Right now, it makes the log overflow on Travis because many of our
  210. # dependencies don't build cleanly this way.
  211. cmake_options=(
  212. -Wdeprecated
  213. -DCMAKE_BUILD_TYPE=Debug
  214. )
  215. if [[ -n "${SANITIZERS:-}" ]]; then
  216. for sanitizer in $SANITIZERS; do
  217. case "$sanitizer" in
  218. asan)
  219. xcb_flags+=(
  220. -enableAddressSanitizer YES
  221. )
  222. cmake_options+=(
  223. -DWITH_ASAN=ON
  224. )
  225. ;;
  226. tsan)
  227. xcb_flags+=(
  228. -enableThreadSanitizer YES
  229. )
  230. cmake_options+=(
  231. -DWITH_TSAN=ON
  232. )
  233. ;;
  234. ubsan)
  235. xcb_flags+=(
  236. -enableUndefinedBehaviorSanitizer YES
  237. )
  238. cmake_options+=(
  239. -DWITH_UBSAN=ON
  240. )
  241. ;;
  242. *)
  243. echo "Unknown sanitizer '$sanitizer'" 1>&2
  244. exit 1
  245. ;;
  246. esac
  247. done
  248. fi
  249. case "$product-$platform-$method" in
  250. FirebasePod-iOS-*)
  251. RunXcodebuild \
  252. -workspace 'CoreOnly/Tests/FirebasePodTest/FirebasePodTest.xcworkspace' \
  253. -scheme "FirebasePodTest" \
  254. "${xcb_flags[@]}" \
  255. build
  256. ;;
  257. Auth-*-xcodebuild)
  258. if check_secrets; then
  259. RunXcodebuild \
  260. -workspace 'FirebaseAuth/Tests/Sample/AuthSample.xcworkspace' \
  261. -scheme "Auth_ApiTests" \
  262. "${xcb_flags[@]}" \
  263. test
  264. RunXcodebuild \
  265. -workspace 'FirebaseAuth/Tests/Sample/AuthSample.xcworkspace' \
  266. -scheme "SwiftApiTests" \
  267. "${xcb_flags[@]}" \
  268. test
  269. fi
  270. ;;
  271. CombineSwift-*-xcodebuild)
  272. pod_gen FirebaseCombineSwift.podspec --platforms=ios
  273. RunXcodebuild \
  274. -workspace 'gen/FirebaseCombineSwift/FirebaseCombineSwift.xcworkspace' \
  275. -scheme "FirebaseCombineSwift-Unit-unit" \
  276. "${xcb_flags[@]}" \
  277. build \
  278. test
  279. ;;
  280. InAppMessaging-*-xcodebuild)
  281. RunXcodebuild \
  282. -workspace 'FirebaseInAppMessaging/Tests/Integration/DefaultUITestApp/InAppMessagingDisplay-Sample.xcworkspace' \
  283. -scheme 'FiamDisplaySwiftExample' \
  284. "${xcb_flags[@]}" \
  285. test
  286. ;;
  287. Firestore-*-xcodebuild)
  288. "${firestore_emulator}" start
  289. trap '"${firestore_emulator}" stop' ERR EXIT
  290. RunXcodebuild \
  291. -workspace 'Firestore/Example/Firestore.xcworkspace' \
  292. -scheme "Firestore_IntegrationTests_$platform" \
  293. -enableCodeCoverage YES \
  294. "${xcb_flags[@]}" \
  295. test
  296. ;;
  297. Firestore-macOS-cmake | Firestore-Linux-cmake)
  298. "${firestore_emulator}" start
  299. trap '"${firestore_emulator}" stop' ERR EXIT
  300. (
  301. test -d build || mkdir build
  302. cd build
  303. echo "Preparing cmake build ..."
  304. cmake -G Ninja "${cmake_options[@]}" ..
  305. echo "Building cmake build ..."
  306. ninja -k 10 all
  307. ctest --verbose
  308. )
  309. ;;
  310. SymbolCollision-*-*)
  311. RunXcodebuild \
  312. -workspace 'SymbolCollisionTest/SymbolCollisionTest.xcworkspace' \
  313. -scheme "SymbolCollisionTest" \
  314. "${xcb_flags[@]}" \
  315. build
  316. ;;
  317. # TODO(#12205) Restore this test to "test" instead of "build"
  318. Messaging-*-xcodebuild)
  319. pod_gen FirebaseMessaging.podspec --platforms=ios
  320. # Add GoogleService-Info.plist to generated Test Wrapper App.
  321. ruby ./scripts/update_xcode_target.rb gen/FirebaseMessaging/Pods/Pods.xcodeproj \
  322. AppHost-FirebaseMessaging-Unit-Tests \
  323. ../../../FirebaseMessaging/Tests/IntegrationTests/Resources/GoogleService-Info.plist
  324. if check_secrets; then
  325. # Integration tests are only run on iOS to minimize flake failures.
  326. RunXcodebuild \
  327. -workspace 'gen/FirebaseMessaging/FirebaseMessaging.xcworkspace' \
  328. -scheme "FirebaseMessaging-Unit-integration" \
  329. "${ios_flags[@]}" \
  330. "${xcb_flags[@]}" \
  331. build
  332. fi
  333. ;;
  334. MessagingSample-*-*)
  335. if check_secrets; then
  336. RunXcodebuild \
  337. -workspace 'FirebaseMessaging/Apps/Sample/Sample.xcworkspace' \
  338. -scheme "Sample" \
  339. "${xcb_flags[@]}" \
  340. build
  341. fi
  342. ;;
  343. SwiftUISample-*-*)
  344. if check_secrets; then
  345. RunXcodebuild \
  346. -workspace 'FirebaseMessaging/Apps/SwiftUISample/SwiftUISample.xcworkspace' \
  347. -scheme "SwiftUISample" \
  348. "${xcb_flags[@]}" \
  349. build
  350. fi
  351. ;;
  352. # TODO: This is actually building for iOS instead of watchOS. Update to use
  353. # watchOS xcb_flags along with the watchOS sdk option. Also nanopb and promises
  354. # podspecs need minimum version updates.
  355. MessagingSampleStandaloneWatchApp-*-*)
  356. if check_secrets; then
  357. RunXcodebuild \
  358. -workspace 'FirebaseMessaging/Apps/SampleStandaloneWatchApp/SampleStandaloneWatchApp.xcworkspace' \
  359. -scheme "SampleStandaloneWatchApp Watch App" \
  360. -destination 'platform=watchOS Simulator,name=Apple Watch Series 7 (45mm)' \
  361. build
  362. fi
  363. ;;
  364. MLModelDownloaderSample-*-*)
  365. if check_secrets; then
  366. RunXcodebuild \
  367. -workspace 'FirebaseMLModelDownloader/Apps/Sample/MLDownloaderTestApp.xcworkspace' \
  368. -scheme "MLDownloaderTestApp" \
  369. "${xcb_flags[@]}" \
  370. build
  371. fi
  372. ;;
  373. WatchOSSample-*-*)
  374. RunXcodebuild \
  375. -workspace 'Example/watchOSSample/SampleWatchApp.xcworkspace' \
  376. -scheme "SampleWatchAppWatchKitApp" \
  377. "${xcb_flags[@]}" \
  378. build
  379. ;;
  380. Database-*-integration)
  381. "${database_emulator}" start
  382. trap '"${database_emulator}" stop' ERR EXIT
  383. pod_gen FirebaseDatabase.podspec --platforms="${gen_platform}"
  384. RunXcodebuild \
  385. -workspace 'gen/FirebaseDatabase/FirebaseDatabase.xcworkspace' \
  386. -scheme "FirebaseDatabase-Unit-integration" \
  387. "${xcb_flags[@]}" \
  388. build \
  389. test
  390. ;;
  391. RemoteConfig-*-fakeconsole)
  392. pod_gen FirebaseRemoteConfigSwift.podspec --platforms="${gen_platform}"
  393. RunXcodebuild \
  394. -workspace 'gen/FirebaseRemoteConfigSwift/FirebaseRemoteConfigSwift.xcworkspace' \
  395. -scheme "FirebaseRemoteConfigSwift-Unit-fake-console-tests" \
  396. "${xcb_flags[@]}" \
  397. build \
  398. test
  399. ;;
  400. RemoteConfig-*-integration)
  401. pod_gen FirebaseRemoteConfigSwift.podspec --platforms="${gen_platform}"
  402. # Add GoogleService-Info.plist to generated Test Wrapper App.
  403. ruby ./scripts/update_xcode_target.rb gen/FirebaseRemoteConfigSwift/Pods/Pods.xcodeproj \
  404. AppHost-FirebaseRemoteConfigSwift-Unit-Tests \
  405. ../../../FirebaseRemoteConfigSwift/Tests/SwiftAPI/GoogleService-Info.plist
  406. # Add AccessToken to generated Test Wrapper App.
  407. ruby ./scripts/update_xcode_target.rb gen/FirebaseRemoteConfigSwift/Pods/Pods.xcodeproj \
  408. AppHost-FirebaseRemoteConfigSwift-Unit-Tests \
  409. ../../../FirebaseRemoteConfigSwift/Tests/AccessToken.json
  410. RunXcodebuild \
  411. -workspace 'gen/FirebaseRemoteConfigSwift/FirebaseRemoteConfigSwift.xcworkspace' \
  412. -scheme "FirebaseRemoteConfigSwift-Unit-swift-api-tests" \
  413. "${xcb_flags[@]}" \
  414. build \
  415. test
  416. ;;
  417. RemoteConfigSample-*-*)
  418. RunXcodebuild \
  419. -workspace 'FirebaseRemoteConfig/Tests/Sample/RemoteConfigSampleApp.xcworkspace' \
  420. -scheme "RemoteConfigSampleApp" \
  421. "${xcb_flags[@]}" \
  422. build
  423. ;;
  424. VertexSample-*-*)
  425. RunXcodebuild \
  426. -project 'FirebaseVertexAI/Sample/VertexAISample.xcodeproj' \
  427. -scheme "VertexAISample" \
  428. "${xcb_flags[@]}" \
  429. build
  430. ;;
  431. Sessions-*-integration)
  432. # Perform "pod install" to install the relevant dependencies
  433. # ./FirebaseSessions/generate_testapp.sh
  434. pod_gen FirebaseSessions.podspec --platforms=ios --clean
  435. cd FirebaseSessions/Tests/TestApp; pod install; cd -
  436. # Run E2E Integration Tests for Prod.
  437. RunXcodebuild \
  438. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  439. -scheme "AppQualityDevApp_iOS" \
  440. "${ios_flags[@]}" \
  441. "${xcb_flags[@]}" \
  442. build \
  443. test
  444. # Run E2E Integration Tests for Staging.
  445. RunXcodebuild \
  446. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  447. -scheme "AppQualityDevApp_iOS" \
  448. FirebaseSessionsRunEnvironment=STAGING \
  449. "${ios_flags[@]}" \
  450. "${xcb_flags[@]}" \
  451. build \
  452. test
  453. # Run E2E Integration Tests for Autopush.
  454. RunXcodebuild \
  455. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  456. -scheme "AppQualityDevApp_iOS" \
  457. FirebaseSessionsRunEnvironment=AUTOPUSH \
  458. "${ios_flags[@]}" \
  459. "${xcb_flags[@]}" \
  460. build \
  461. test
  462. ;;
  463. StorageSwift-*-xcodebuild)
  464. pod_gen FirebaseStorage.podspec --platforms=ios
  465. # Add GoogleService-Info.plist to generated Test Wrapper App.
  466. ruby ./scripts/update_xcode_target.rb gen/FirebaseStorage/Pods/Pods.xcodeproj \
  467. AppHost-FirebaseStorage-Unit-Tests \
  468. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  469. if check_secrets; then
  470. # Integration tests are only run on iOS to minimize flake failures.
  471. RunXcodebuild \
  472. -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
  473. -scheme "FirebaseStorage-Unit-integration" \
  474. "${ios_flags[@]}" \
  475. "${xcb_flags[@]}" \
  476. test
  477. fi
  478. ;;
  479. StorageObjC-*-xcodebuild)
  480. pod_gen FirebaseStorage.podspec --platforms=ios
  481. # Add GoogleService-Info.plist to generated Test Wrapper App.
  482. ruby ./scripts/update_xcode_target.rb gen/FirebaseStorage/Pods/Pods.xcodeproj \
  483. AppHost-FirebaseStorage-Unit-Tests \
  484. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  485. if check_secrets; then
  486. # Integration tests are only run on iOS to minimize flake failures.
  487. RunXcodebuild \
  488. -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
  489. -scheme "FirebaseStorage-Unit-ObjCIntegration" \
  490. "${ios_flags[@]}" \
  491. "${xcb_flags[@]}" \
  492. test
  493. fi
  494. ;;
  495. StorageCombine-*-xcodebuild)
  496. pod_gen FirebaseCombineSwift.podspec --platforms=ios
  497. # Add GoogleService-Info.plist to generated Test Wrapper App.
  498. ruby ./scripts/update_xcode_target.rb gen/FirebaseCombineSwift/Pods/Pods.xcodeproj \
  499. AppHost-FirebaseCombineSwift-Unit-Tests \
  500. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  501. if check_secrets; then
  502. # Integration tests are only run on iOS to minimize flake failures.
  503. RunXcodebuild \
  504. -workspace 'gen/FirebaseCombineSwift/FirebaseCombineSwift.xcworkspace' \
  505. -scheme "FirebaseCombineSwift-Unit-integration" \
  506. "${ios_flags[@]}" \
  507. "${xcb_flags[@]}" \
  508. test
  509. fi
  510. ;;
  511. GoogleDataTransport-watchOS-xcodebuild)
  512. RunXcodebuild \
  513. -workspace 'GoogleDataTransport/GDTWatchOSTestApp/GDTWatchOSTestApp.xcworkspace' \
  514. -scheme "GDTWatchOSTestAppWatchKitApp" \
  515. "${xcb_flags[@]}" \
  516. build
  517. RunXcodebuild \
  518. -workspace 'GoogleDataTransport/GDTCCTWatchOSTestApp/GDTCCTWatchOSTestApp.xcworkspace' \
  519. -scheme "GDTCCTWatchOSIndependentTestAppWatchKitApp" \
  520. "${xcb_flags[@]}" \
  521. build
  522. RunXcodebuild \
  523. -workspace 'GoogleDataTransport/GDTCCTWatchOSTestApp/GDTCCTWatchOSTestApp.xcworkspace' \
  524. -scheme "GDTCCTWatchOSCompanionTestApp" \
  525. "${xcb_flags[@]}" \
  526. build
  527. ;;
  528. Performance-*-unit)
  529. # Run unit tests on prod environment with unswizzle capabilities.
  530. export FPR_UNSWIZZLE_AVAILABLE="1"
  531. export FPR_AUTOPUSH_ENV="0"
  532. pod_gen FirebasePerformance.podspec --platforms="${gen_platform}"
  533. RunXcodebuild \
  534. -workspace 'gen/FirebasePerformance/FirebasePerformance.xcworkspace' \
  535. -scheme "FirebasePerformance-Unit-unit" \
  536. "${xcb_flags[@]}" \
  537. build \
  538. test
  539. ;;
  540. Performance-*-proddev)
  541. # Build the prod dev test app.
  542. export FPR_UNSWIZZLE_AVAILABLE="0"
  543. export FPR_AUTOPUSH_ENV="0"
  544. pod_gen FirebasePerformance.podspec --platforms="${gen_platform}"
  545. RunXcodebuild \
  546. -workspace 'gen/FirebasePerformance/FirebasePerformance.xcworkspace' \
  547. -scheme "FirebasePerformance-TestApp" \
  548. "${xcb_flags[@]}" \
  549. build
  550. ;;
  551. Performance-*-integration)
  552. # Generate the workspace for the SDK to generate Protobuf files.
  553. export FPR_UNSWIZZLE_AVAILABLE="0"
  554. pod_gen FirebasePerformance.podspec --platforms=ios --clean
  555. # Perform "pod install" to install the relevant dependencies
  556. cd FirebasePerformance/Tests/FIRPerfE2E; pod install; cd -
  557. # Run E2E Integration Tests for Autopush.
  558. RunXcodebuild \
  559. -workspace 'FirebasePerformance/Tests/FIRPerfE2E/FIRPerfE2E.xcworkspace' \
  560. -scheme "FIRPerfE2EAutopush" \
  561. FPR_AUTOPUSH_ENV=1 \
  562. "${ios_flags[@]}" \
  563. "${xcb_flags[@]}" \
  564. build \
  565. test
  566. # Run E2E Integration Tests for Prod.
  567. RunXcodebuild \
  568. -workspace 'FirebasePerformance/Tests/FIRPerfE2E/FIRPerfE2E.xcworkspace' \
  569. -scheme "FIRPerfE2EProd" \
  570. "${ios_flags[@]}" \
  571. "${xcb_flags[@]}" \
  572. build \
  573. test
  574. ;;
  575. # Note that the combine tests require setting the minimum iOS and tvOS version to 13.0
  576. *-*-spm)
  577. RunXcodebuild \
  578. -scheme $product \
  579. "${xcb_flags[@]}" \
  580. IPHONEOS_DEPLOYMENT_TARGET=13.0 \
  581. TVOS_DEPLOYMENT_TARGET=13.0 \
  582. test
  583. ;;
  584. *-*-spmbuildonly)
  585. RunXcodebuild \
  586. -scheme $product \
  587. "${xcb_flags[@]}" \
  588. build
  589. ;;
  590. ClientApp-iOS-xcodebuild | ClientApp-iOS13-iOS-xcodebuild)
  591. RunXcodebuild \
  592. -project 'IntegrationTesting/ClientApp/ClientApp.xcodeproj' \
  593. -scheme $product \
  594. "${xcb_flags[@]}" \
  595. build
  596. ;;
  597. ClientApp-CocoaPods*-iOS-xcodebuild)
  598. RunXcodebuild \
  599. -workspace 'IntegrationTesting/ClientApp/ClientApp.xcworkspace' \
  600. -scheme $product \
  601. "${xcb_flags[@]}" \
  602. build
  603. ;;
  604. *)
  605. echo "Don't know how to build this product-platform-method combination" 1>&2
  606. echo " product=$product" 1>&2
  607. echo " platform=$platform" 1>&2
  608. echo " method=$method" 1>&2
  609. exit 1
  610. ;;
  611. esac